import { OnInit, Input, Component, ViewChild } from '@angular/core';
import { CheckBoxSelectionService } from '@syncfusion/ej2-angular-dropdowns';
import { ControlValueAccessor, NG_VALUE_ACCESSOR } from '@angular/forms';

@Component({
  selector: 'app-multiselect',
  templateUrl: './multiselect.component.html',
  styleUrls: ['./multiselect.component.css'],
  providers: [{
    provide: NG_VALUE_ACCESSOR,
    useExisting: MultiselectComponent,
    multi: true
  },
  CheckBoxSelectionService
]
})
export class MultiselectComponent implements OnInit, ControlValueAccessor {

  @ViewChild('ej2Element', { static: false}) ej2Element;

  @Input()
  dataSource: any;

  @Input()
  fields: any;

  @Input()
  placeholder: string;

  @Input()
  width: any;

  value: any;

  onChange: any;
  onTouched: any;

  disabled: boolean;

  writeValue(obj: any): void {
    this.value = obj;
  }
  registerOnChange(fn: any): void {
    this.onChange = fn;
  }
  registerOnTouched(fn: any): void {
    this.onTouched = fn;
  }

  setDisabledState?(isDisabled: boolean): void {
    this.disabled = isDisabled;
  }

  onSelectedValuesChange(evt){
    if (this.onChange) {
      this.onChange(evt.value);
    }
  }

  constructor() { }

  ngOnInit() {
  }

}
